/// <reference path="typings/tp.d.ts">/>
/// <reference path="typings/game-object.d.ts">/>

/** START SHARED **/
const SlotsColorName = ['Blue', 'Green', 'Red', 'DarkGreen', 'Purple', 'Pink', 'Orange', 'Brown', 'White', 'Yellow'];
const BasicColors = {
  white: new Color(255, 255, 255, 255),
  black: new Color(0, 0, 0, 255),
  red: new Color(255, 0, 0, 255),
  green: new Color(0, 255, 0, 255),
  blue: new Color(0, 0, 255, 255),
  yellow: new Color(255, 255, 0, 255),
  orange: new Color(255, 165, 0, 255),
  magenta: new Color(255, 0, 255, 255),
};
/** END SHARED **/

refObject.setName('Grab this to pick random player');
refObject.onReleased.add((_, interPlayer) => {
  const rndPlayer = getRandomPlayer();
  const rndPlayerColor = SlotsColorName[rndPlayer.getSlot()];
  const clickPlayerColor = SlotsColorName[interPlayer.getSlot()];
  world.broadcastChatMessage(`Player ${interPlayer.getName()} (${clickPlayerColor}) picks ${rndPlayer.getName()} (${rndPlayerColor})`, BasicColors.white);
});

function getRandomPlayer() {
  const players = world.getAllPlayers();
  const randomIdx = getRandomInt(0, players.length - 1);
  return players[randomIdx];
}

function getRandomInt(min, max) {
  min = Math.ceil(min);
  max = Math.floor(max);
  return Math.floor(Math.random() * (max - min + 1)) + min;
}
